test dev:
  stage: test
  extends:
    - .rules_dev
  variables:
    CONFIG: $CONFIG_DEV
  script:
    - dotnet test --no-build --configuration $CONFIG --collect:"XPlat Code Coverage" --results-directory ./
  artifacts:
    paths:
      - '*/coverage.cobertura.xml'
    expire_in: 2 hours

test release:
  extends:
    - test dev
    - .rules_release
  variables:
    CONFIG: $CONFIG_RELEASE

version check dev:
  stage: test
  extends:
    - .rules_dev
  needs: []
  cache: {}
  variables:
    PROJECT_PATH: ./*/*.csproj
    PROJECT_FILTER: '*Tests*'
  script:
    - >-
      pwsh -Command 'if ($env:CI_JOB_NAME -eq "version check release") {
          Write-Host "Tag version : ${env:CI_COMMIT_TAG}"
      }
      $projects = @(Get-ChildItem -Path $env:PROJECT_PATH -Exclude $env:PROJECT_FILTER) ;
      if ($projects.Count -gt 1) {
          Write-Warning "More than one project found. Only the first project will be used for the PROJECT_VERSION variable."
      }
      $timestamp = Get-Date -Format "yyMMddHHmm" ;
      Write-Host "Version timestamp : $timestamp" ;
      $releasesUri = "https://gitlab.com/api/v4/projects/${env:CI_PROJECT_ID}/releases" ;
      $releasesRsp = Invoke-RestMethod -Uri $releasesUri -Headers @{ "JOB-TOKEN" = $env:CI_JOB_TOKEN } ;
      $releases = $releasesRsp | Select-Object -ExpandProperty name ;
      for ($p = 0; $p -lt $projects.Count; $p++) {
          $projPath = $projects[$p] ;
          Write-Host "Checking $($projPath.BaseName)" ;
          $csproj = Get-Content $projPath.FullName -Raw ;
          $csproj -match "<Version>(.+?)(\$\(VersionSuffix\))?</Version>" | Out-Null ;
          $version = "v" + $Matches[1] ;
          Write-Host "Project version    : $version" ;
          if ($env:CI_JOB_NAME -ne "version check release" -and $version -in $releases) {
              Write-Host -Fore Red "ERROR: A release for this version ($version) already exists." ;
              exit 1
          }
          if ($p -eq 0) {
              if ($version -match "-(.+)$") {
                  $suffix = ""
              } else {
                  $suffix = "-" + $env:DEFAULT_PRERELEASE_VERSION
              }
              if ($env:CI_COMMIT_BRANCH -eq $env:CI_DEFAULT_BRANCH) {
                  $suffix += ".main"
              } else {
                  $suffix += ".dev"
              }
              $suffix += ".$timestamp" ;
              Write-Host "Version suffix     : $suffix" ;
              Write-Host "Dev/main version : ${version}${suffix}" ;
              "PROJECT_VERSION=$version`nVERSION_SUFFIX=$suffix`nVERSION_TIMESTAMP=$timestamp" |
                  Out-File -FilePath ./version.env -Encoding ascii ;
              "${version}${suffix}" | Out-File -FilePath ./version.txt -Encoding ascii ;
          }
          if ($env:CI_JOB_NAME -eq "version check release" -and $version -ne $env:CI_COMMIT_TAG) {
              Write-Host -Fore Red "ERROR: The project version $version does not match the release tag version ${env:CI_COMMIT_TAG}" ;
              exit 1
          }
      }'
  artifacts:
    reports:
      dotenv: version.env
    expose_as: Build Version
    paths: ['version.txt']

version check release:
  extends:
    - version check dev
    - .rules_release
